import query_llama
import csv
import random

"""
CS 232 HW 8: Prompt Engineering for PuzzleQA dataset
"""

def readDataset():
	with open("puzzleQA.tsv",'r') as of:
		reader = csv.DictReader(of, delimiter="\t",)
		lines = [row for row in reader]
	return lines

def basic_mc_prompt(item):
	prompt = f"Explanation: {item['explanation']}\nQuestion: {item['question']}\n"
	choices = [item[f"opt{i}"] for i in range(4)]
	correct = choices[int(item["gold"])]
	random.shuffle(choices)
	for i,c in enumerate(choices):
		prompt += f"Choice {i}: {c}\n"
	prompt+="Answer: Choice"
	return prompt, str(choices.index(correct))

def fewshot_mc_prompt(item):
	pass

def cot_mc_prompt(item):
	pass

def mc_score(response,correctAnswer):
	return 1 if correctAnswer in response else 0

def runMCtask(data,prompt_fn,token_limit=10):
	total = 0
	for item in data:
		prompt, answerNumber = prompt_fn(item)
		response = query_llama.completion_query(prompt,max_tokens=token_limit)
		total += mc_score(response,answerNumber)
	print("Percent correct: ",total/len(data))
	return total

def generation_prompt():
	pass

def runGenerationTask(tries,token_limit=100):
	games = []
	# To fill in
	return games

def export(games,fn="generated_games.txt"):
	with open(fn,'w') as of:
		for i,g in enumerate(games):
			of.write(f"GAME {i}\n{g}\n")

def main():
	dataset = readDataset()
	score = runMCtask(dataset,basic_mc_prompt)

if __name__ == "__main__":
    main()
